unit Unit1;
{ AFClpPrt Ver 1.0  Programmed by AF 1999/06/07 }

{
@̃vÓArbg}bv`Nbv{[h
@f[^ƁAv^ֈvO
@łBNbv{[h̃rbg}bvf[^͍폜܂B
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, Clipbrd, Printers, Unit2 ;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    MnuFile: TMenuItem;
    MnuPrinterSet: TMenuItem;
    MnuExit: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    Image1: TImage;
    Timer1: TTimer;
    MnuSet: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure MnuExitClick(Sender: TObject);
    procedure MnuPrinterSetClick(Sender: TObject);
    procedure MnuSetClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
    PrMode : Integer ;
    PrSize1 : double ;
    PrSize2 : double ;
    PrDotPx : Integer ;
    PrRatio : Boolean ;
	 procedure PrintImage ;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ start }
procedure TForm1.FormShow(Sender: TObject);
begin
	PrMode  := 0 ;
   PrSize1 := 100.0 ;
   PrSize2 := 100.0 ;
   PrDotPx := 1 ;
   PrRatio := True ;
end;

{ Menu|Exit }
procedure TForm1.MnuExitClick(Sender: TObject);
begin
	close ;
end;

{ Menu|PrinterSet }
procedure TForm1.MnuPrinterSetClick(Sender: TObject);
begin
	Timer1.Enabled := False ;

	PrinterSetupDialog1.Execute ;

	Timer1.Interval := 1000 ;
	Timer1.Enabled := True ;
end;

{ Menu|Set }
procedure TForm1.MnuSetClick(Sender: TObject);
begin
	Timer1.Enabled := False ;

	Form2.SelectNo := PrMode ;
	Form2.Size1    := PrSize1 ;
	Form2.Size2    := PrSize2 ;
	Form2.DotPxs   := PrDotPx ;
	Form2.Ratio    := PrRatio ;
	Form2.ShowModal ;
   if (Form2.OKflag) then begin
		PrMode  := Form2.SelectNo ;
      PrSize1 := Form2.Size1 ;
      PrSize2 := Form2.Size2 ;
      PrDotPx := Form2.DotPxs ;
      PrRatio := Form2.Ratio ;
   end;

	Timer1.Interval := 1000 ;
	Timer1.Enabled := True ;
end;

{ TimerONɂȂNbv{[h̃`FbN }
procedure TForm1.Timer1Timer(Sender: TObject);
begin
	Timer1.Enabled := False ;
	if (Clipboard.HasFormat(CF_PICTURE)) then begin
   	with Image1 do begin
      	Picture.Assign(Clipboard);
         Height := Picture.Height ;
         Width  := Picture.Width  ;
      end;
      Clipboard.Clear ;
      PrintImage ;
	end;
	Timer1.Interval := 1000 ;
	Timer1.Enabled := True ;
end;

{ Imagë }
procedure TForm1.PrintImage ;
var
	d,d1,d2 : double ;
   isz1,isz2 :Integer ;
	r : TRect ;
	ALeft, ATop, ARight, ABottom: Integer ;
begin
   d1 := Image1.Width ;
	d2 := Image1.Height ;
   if (d1 < 1.0) then d1 := 1.0 ;
   d :=  d2 / d1 ;
	d1 := GetDeviceCaps(Printer.Handle, LOGPIXELSX) ;
	d2 := GetDeviceCaps(Printer.Handle, LOGPIXELSY) ;
   isz1 := Round(PrSize1/25.4*d1) ;
   if (PrRatio) then
      isz2 := Round(PrSize1*d/25.4*d2)
   else
      isz2 := Round(PrSize2  /25.4*d2) ;

   case (PrMode) of
   1: begin    { 1 dot = N printer pixel (Left) }
         ALeft   := 0 ;
         ATop    := 0 ;
         ARight  := Image1.Width  * PrDotPx ;
         ABottom := Image1.Height * PrDotPx ;
      end;
   2: begin    { 1 dot = N printer pixel (Center) }
         ALeft   := Printer.PageWidth  div 2 - Image1.Width  * PrDotPx div 2 ;
         Atop    := Printer.PageHeight div 2 - Image1.Height * PrDotPx div 2 ;
         ARight  := Printer.PageWidth  div 2 + Image1.Width  * PrDotPx div 2 ;
         ABottom := Printer.PageHeight div 2 + Image1.Height * PrDotPx div 2 ;
      end;
   3: begin    { Specify the printing size (Left) }
         ALeft   := 0 ;
         ATop    := 0 ;
         ARight  := isz1 ;
         ABottom := isz2 ;
      end;
   4: begin    { Specify the printing size (Center) }
         ALeft   := Printer.PageWidth  div 2 - isz1 div 2 ;
         Atop    := Printer.PageHeight div 2 - isz2 div 2 ;
         ARight  := Printer.PageWidth  div 2 + isz1 div 2 ;
         ABottom := Printer.PageHeight div 2 + isz2 div 2 ;
      end;
   else
      begin    { fit }
         ALeft   := 0 ;
         ATop    := 0 ;
         ARight  := Printer.PageWidth ;
         ABottom := Printer.PageHeight ;
      end;
   end;
	with Printer do begin
      Printer.Title := 'AFClpPrt' ;
   	BeginDoc ;
		r := Rect(ALeft, ATop, ARight, ABottom);
		Canvas.StretchDraw(r, Image1.Picture.Graphic);
		EndDoc ;
   end;
end;

end.
